<?php
/**************************************************
  Coppermine 1.5.x Plugin - flf_flashcloud
  *************************************************
  Copyright (c) 2010 Florian Lechner (www.lounge-lizard.org/cms)
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version.
  **************************************************/

require('plugins/flf_flashcloud/include/flashcloud_include.php');


if (in_array('plugins/flf_flashcloud/js/farbtastic.js', $JS['includes']) != TRUE) {
	$JS['includes'][] = 'plugins/flf_flashcloud/js/farbtastic.js';
}
if (in_array('plugins/flf_flashcloud/js/config.js', $JS['includes']) != TRUE) {
	$JS['includes'][] = 'plugins/flf_flashcloud/js/admin.js';
}

global $CONFIG, $lang_errors,$lang_plugin_flashcloud;
// create Inspekt supercage
$superCage = Inspekt::makeSuperCage();

if (!GALLERY_ADMIN_MODE) {
    cpg_die(ERROR, $lang_errors['access_denied'], __FILE__, __LINE__);
}

// text direction
if($lang_text_dir=='ltr') {
  $align="left";
  $direction="ltr";
}else {
  $align="right";
  $direction="rtl";
}

// get sanitized POST parameters
if ($superCage->post->keyExists('submit')) {
	//Check if the form token is valid
	if(!checkFormToken()){
		cpg_die(ERROR, $lang_errors['invalid_form_token'], __FILE__, __LINE__);
	}
  // Define the sanitization patterns
  $sanitization_array = array(
  	  'plugin_flf_flashcloud_hideprivatetags' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),
	  'plugin_flf_flashcloud_autogenerate' => array('type' => 'checkbox', 'min' => '0', 'max' => '1'),
      'plugin_flf_flashcloud_colhighlight' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
     'plugin_flf_flashcloud_col_1' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_2' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_3' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_4' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_5' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_6' =>array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_7' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_8' =>array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_9' =>array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
      'plugin_flf_flashcloud_col_10' => array('type' => 'raw', 'regex_ok' => '/^#(?:(?:[a-f\d]{3}){1,2})$/i'),
     'plugin_flf_flashcloud_mincount' => array('type' => 'int', 'min' => '1', 'max' => '99'),
     'plugin_flf_flashcloud_threshold' => array('type' => 'int', 'min' => '1', 'max' => '99'),
       'plugin_flf_flashcloud_minsize' => array('type' => 'int', 'min' => '1', 'max' => '99'),
       'plugin_flf_flashcloud_maxsize' => array('type' => 'int', 'min' => '1', 'max' => '99'),
    'main_page_layout' => array(
      'type'          => 'flf_special',
      'regex'         => 'wirdnichtausgewertet',
    )
	);
  $config_changes_counter = 0;
  foreach ($sanitization_array as $san_key => $san_value) {
      if (isset($CONFIG[$san_key]) == TRUE) { // only loop if config value is set --- start
          if ($san_value['type'] == 'checkbox') { // type is checkbox --- start
            if ($superCage->post->getInt($san_key) == $san_value['max'] && $CONFIG[$san_key] != $san_value['max']) {
                $CONFIG[$san_key] = $san_value['max'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->getInt($san_key) == $san_value['min'] && $CONFIG[$san_key] != $san_value['min']) {
                $CONFIG[$san_key] = $san_value['min'];
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            } elseif($superCage->post->keyExists($san_key) != TRUE && $CONFIG[$san_key] != '0') {
                $CONFIG[$san_key] = 0;
                cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                $config_changes_counter++;
            }
          } // type is checkbox --- end
          if ($san_value['type'] == 'int') { // type is integer --- start
              if ($superCage->post->getInt($san_key) <= $san_value['max'] && $superCage->post->getInt($san_key) >= $san_value['min'] && $superCage->post->getInt($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getInt($san_key);
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is integer --- end
          if ($san_value['type'] == 'raw') { // type is raw --- start
              if (isset($san_value['regex_ok']) == TRUE && preg_match($san_value['regex_ok'], $superCage->post->getRaw($san_key)) && $superCage->post->getRaw($san_key) != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $superCage->post->getRaw($san_key);
				  if ($superCage->post->getRaw($san_key) == 'none') {
					$CONFIG[$san_key] = '';
				  }
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is raw --- end
		            if ($san_value['type'] == 'flf_special') { // type is flf_special without regex check; wasn't able to get the regex to work-sorry.
                $CONFIG[$san_key] = $superCage->post->getRaw($san_key);
				  if ($superCage->post->getRaw($san_key) == 'none') {
					$CONFIG[$san_key] = '';
				  
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is raw --- end
          if ($san_value['type'] == 'array') { // type is array --- start              
          $evaluate_value = $superCage->post->getRaw($san_key);
              //print_r($superCage->post->getRaw($san_key));
              if (is_array($evaluate_value) && isset($san_value['regex_ok']) == TRUE && isset($san_value['delimiter']) == TRUE) {
                  $temp = '';
                  for ($i = 0; $i <= count($evaluate_value); $i++) {
                      if (preg_match($san_value['regex_ok'], $evaluate_value[$i])) {
                          $temp .= $evaluate_value[$i] . $san_value['delimiter'];
                      }
                  }
                  unset($evaluate_value);
                  $evaluate_value = rtrim($temp, $san_value['delimiter']);
                  unset($temp);
              }
              if ($evaluate_value != $CONFIG[$san_key]) {
                  $CONFIG[$san_key] = $evaluate_value;
                  cpg_db_query("UPDATE {$CONFIG['TABLE_CONFIG']} SET value='{$CONFIG[$san_key]}' WHERE name='$san_key'");
                  $config_changes_counter++;
              }
          } // type is array --- end
      } // only loop if config value is set --- end
  }
}


// display config page

// Set the option output stuff 
if ($CONFIG['plugin_flf_flashcloud_hideprivatetags'] == '1') {
	$option_output['plugin_flf_flashcloud_hideprivatetags'] = 'checked="checked"';
} else { 
	$option_output['plugin_flf_flashcloud_hideprivatetags'] = '';
}
if ($CONFIG['plugin_flf_flashcloud_autogenerate'] == '1') {
	$option_output['plugin_flf_flashcloud_autogenerate'] = 'checked="checked"';
} else { 
	$option_output['plugin_flf_flashcloud_autogenerate'] = '';
}

pageheader($lang_plugin_flashcloud['display_name']);
list($timestamp, $form_token) = getFormToken();
echo <<< EOT
<form action="index.php?file=flf_flashcloud/admin" method="post" name="flf_flashcloud_settings">
EOT;
starttable('100%', $enlargeit_icon_array['table'] . $lang_plugin_flashcloud['plugin_configuration'] . ': ' . $lang_plugin_flashcloud['main_title'] . ' v' . $version, 3, 'cpg_zebra');
echo <<< EOT
	<tr>
		<td class="tablef" colspan="3" >
EOT;
if ($superCage->post->keyExists('submit')) {
    if ($config_changes_counter > 0) {
        msg_box('', $lang_plugin_flashcloud['update_success'], '', '', 'success');
    } else {
        msg_box('', $lang_plugin_flashcloud['no_changes'], '', '', 'validation');
    }
} else {
	echo <<< EOT
	{$lang_plugin_flashcloud['display_name']} &copy; Florian Lechner <a href="www.lounge-lizard.org/cms"> rel="external" class="external">Timos-welt.de</a>)
	<a href="http://forum.coppermine-gallery.net/index.php/" rel="external" class="admin_menu">{$enlargeit_icon_array['announcement']}{$lang_plugin_flashcloud['announcement_thread']}</a>
	<a href="plugins/flf_flashcloud/docs/{$documentation_file}.htm" class="admin_menu">{$enlargeit_icon_array['documentation']}{$lang_plugin_flashcloud['flashcloud_documentation']}</a>

EOT;
}
echo <<< EOT
		</td>
	</tr>
	<tr>
		<td class="tableh1" colspan="3">
			{$lang_plugin_flashcloud['generalsettings']}
		</td>
	</tr>

		<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['startpageposition']}
		</td>
		<td colspan="1">
			<input type="text" name="main_page_layout" id="main_page_layout" class="textinput" size="80" maxlength="255" value="{$CONFIG['main_page_layout']}"  />

		</td>

	</tr>

	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['hideprivatetags']}
		</td>
		<td colspan="1">
			<input type="checkbox" name="plugin_flf_flashcloud_hideprivatetags" id="plugin_flf_flashcloud_hideprivatetags" class="checkbox" value="1" {$option_output['plugin_flf_flashcloud_hideprivatetags']} /><label for="plugin_flf_flashcloud_hideprivatetags" class="clickable_option">{$lang_plugin_flashcloud['hidden']}</label><br />
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['flashcloud_autogenerate']}
		</td>
		<td colspan="1">
			<input type="checkbox" name="plugin_flf_flashcloud_autogenerate" id="plugin_flf_flashcloud_autogenerate" class="checkbox" value="1" {$option_output['plugin_flf_flashcloud_autogenerate']} /><label for="plugin_flf_flashcloud_autogenerate" class="clickable_option">{$lang_plugin_flashcloud['activated']}</label><br />
		</td>

	</tr>

	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['maxsize']}
		</td>
			<td  valign="top" colspan="1">
			<input type="text" name="plugin_flf_flashcloud_maxsize" id="plugin_flf_flashcloud_maxnsize" class="textinput" size="2" maxlength="2" value="{$CONFIG['plugin_flf_flashcloud_maxsize']}" style="text-transform:uppercase;" />
		</td>
	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['minsize']}
		</td>
			<td  valign="top" colspan="1">
			<input type="text" name="plugin_flf_flashcloud_minsize" id="plugin_flf_flashcloud_minsize" class="textinput" size="2" maxlength="2" value="{$CONFIG['plugin_flf_flashcloud_minsize']}" style="text-transform:uppercase;" />
		</td>
	</tr>
		<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['threshold']}
		</td>
			<td  valign="top" colspan="1">
			<input type="text" name="plugin_flf_flashcloud_threshold" id="plugin_flf_flashcloud_threshold" class="textinput" size="2" maxlength="2" value="{$CONFIG['plugin_flf_flashcloud_threshold']}" style="text-transform:uppercase;" />
		</td>
	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['minimumtags']}
		</td>
			<td  valign="top" colspan="1">
			<input type="text" name="plugin_flf_flashcloud_mincount" id="plugin_flf_flashcloud_mincount" class="textinput" size="2" maxlength="2" value="{$CONFIG['plugin_flf_flashcloud_mincount']}" style="text-transform:uppercase;" />
		</td>
	</tr>

	
	<tr>
		<td class="tableh1" colspan="3">
			{$lang_plugin_flashcloud['colortitle']}
		</td>
	</tr>
	<tr>
		<td >
			{$lang_plugin_flashcloud['colhighlight']}
		</td>
		<td  valign="top" colspan="1">
			<input type="text" name="plugin_flf_flashcloud_colhighlight" id="plugin_flf_flashcloud_colhighlight" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_colhighlight']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_highlight" class="detail_body"></div>
		</td>

	</tr>
	
	<tr>
		<td>
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_1']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_1" id="plugin_flf_flashcloud_col_1" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_1']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_1" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_2']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_2" id="plugin_flf_flashcloud_col_2" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_2']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_2" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_3']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_3" id="plugin_flf_flashcloud_col_3" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_3']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_3" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_4']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_4" id="plugin_flf_flashcloud_col_4" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_4']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_4" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_5']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_5" id="plugin_flf_flashcloud_col_5" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_5']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_5" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_6']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_6" id="plugin_flf_flashcloud_col_6" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_6']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_6" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_7']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_7" id="plugin_flf_flashcloud_col_7" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_7']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_7" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_8']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_8" id="plugin_flf_flashcloud_col_8" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_8']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_8" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_9']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_9" id="plugin_flf_flashcloud_col_9" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_9']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_9" class="detail_body"></div>
		</td>

	</tr>
	<tr>
		<td valign="top">
			{$lang_plugin_flashcloud['plugin_flf_flashcloud_col_10']}
		</td>
		<td colspan="1">
			<input type="text" name="plugin_flf_flashcloud_col_10" id="plugin_flf_flashcloud_col_10" class="textinput" size="8" maxlength="7" value="{$CONFIG['plugin_flf_flashcloud_col_10']}" style="text-transform:uppercase;" />
			<span class="detail_head_collapsed">{$lang_plugin_flashcloud['toggle_color_picker']}</span>
			<div id="colorpicker_flashcloud_color_10" class="detail_body"></div>
		</td>

	</tr>

	<tr>
		<td class="tablef" colspan="3">
			<input type="hidden" name="form_token" value="{$form_token}" />
			<input type="hidden" name="timestamp" value="{$timestamp}" />
			<button type="submit" class="button" name="submit" value="{$lang_plugin_enlargeit['submit']}">{$enlargeit_icon_array['ok']}{$lang_plugin_enlargeit['submit']}</button>
		</td>
	</tr>
EOT;

endtable();
echo <<< EOT
</form>
EOT;
pagefooter();



?>